﻿Imports UniversalTicket
Public Class frmMain
    Private Declare Function mciExecute Lib "winmm.dll" (ByVal lpstrCommand As String) As Integer
    Private WithEvents utc As UTicketClient
    Private Sub frmMain_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        verbindungTrennen()
    End Sub
    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        IDvorschalgen()
        guiZustandGetrennt()
    End Sub
    Private Sub IDvorschalgen()
        Dim sUsernameSplit() As String = Split(My.User.Name, "\")
        txtID.Text = sUsernameSplit(UBound(sUsernameSplit))
    End Sub
    Private Sub guiZustandGetrennt()
        grpChat.Enabled = False
        rtbChatAusgabe.Text = ""
        txtChatEingabe.Text = ""
        grpFernsteuerung.Enabled = False
        btnTrennen.Enabled = False
        txtIP.Enabled = True
        txtPort.Enabled = True
        txtID.Enabled = True
        btnVerbinden.Enabled = True
        grpVerbindung.Enabled = True
        picVerbindungsstatus.BackColor = Color.FromKnownColor(KnownColor.Control)
    End Sub
    Private Sub guiZustandVerbinungSteht()
        btnVerbinden.Enabled = False
        txtIP.Enabled = False
        txtPort.Enabled = False
        txtID.Enabled = False
        btnTrennen.Enabled = True
        grpVerbindung.Enabled = True
        grpChat.Enabled = True
        grpFernsteuerung.Enabled = True
        picVerbindungsstatus.BackColor = Color.Green
        txtChatEingabe.Focus()
    End Sub
    Private Sub utc_ConnectionLost(sReason As String) Handles utc.ConnectionLost
        guiZustandGetrennt()
        MsgBox("Verbindung wurde getrennt!" & vbNewLine & vbNewLine & sReason, MsgBoxStyle.Exclamation)
    End Sub
    Private Sub utc_ConnectionNotPossible(sReason As String) Handles utc.ConnectionNotPossible
        guiZustandGetrennt()
        MsgBox("Verbindung konnte nicht hergestellt werden!" & vbNewLine & vbNewLine & sReason, MsgBoxStyle.Exclamation)
    End Sub
    Private Sub verbindungSteht() Handles utc.ConnectionReadyForSending
        guiZustandVerbinungSteht()
    End Sub
    Private Sub guiZustandVerbindungHerstellen()
        guiZustandGetrennt()
        grpVerbindung.Enabled = False
        Application.DoEvents()
    End Sub
    Private Sub btnVerbinden_Click(sender As Object, e As EventArgs) Handles btnVerbinden.Click
        guiZustandVerbindungHerstellen()
        verbindungHerstellen()
    End Sub
    Private Sub verbindungHerstellen()
        utc = New UTicketClient(txtIP.Text, CInt(txtPort.Text), "3290fja39j%§(§&_SERVER-PASSWORD_§=JDf9", Me)
        If utc.isServerAvailable = True Then
            utc.start(txtID.Text)
        Else
            MsgBox("Der Server ist leider gerade offline!", MsgBoxStyle.Exclamation)
            guiZustandGetrennt()
        End If
    End Sub
    Private Sub btnTrennen_Click(sender As Object, e As EventArgs) Handles btnTrennen.Click
        guiZustandGetrennt()
        verbindungTrennen()
    End Sub
    Private Sub verbindungTrennen()
        If utc IsNot Nothing Then
            utc.shutdown()
        End If
    End Sub
    Private Sub utc_IDalreadyInUseConnectionAborted() Handles utc.IDalreadyInUseConnectionAborted
        guiZustandGetrennt()
        MsgBox("Diese ID ist leider bereits vergeben!", MsgBoxStyle.Exclamation)
    End Sub
    Private Sub utc_IDisGone(sID As String) Handles utc.IDisGone
        rtbChatAusgabe.AppendText("[" & getUhrZeit() & "] " & sID & " hat den Server verlassen!" & vbNewLine)
    End Sub
    Private Sub utc_IDjoined(sID As String) Handles utc.IDjoined
        rtbChatAusgabe.AppendText("[" & getUhrZeit() & "] " & sID & " hat den Server betreten!" & vbNewLine)
    End Sub
    Private Sub utc_IDlistChanged(sIDs As List(Of String)) Handles utc.IDlistChanged
        cmbEmpfaengerChat.Items.Clear()
        cmbEmpfaengerSteuerung.Items.Clear()
        For Each ID In sIDs
            cmbEmpfaengerChat.Items.Add(ID)
            cmbEmpfaengerSteuerung.Items.Add(ID)
        Next
        cmbEmpfaengerChat.Items.Add("@all")
        cmbEmpfaengerSteuerung.Items.Add("@all")
        cmbEmpfaengerChat.SelectedIndex = cmbEmpfaengerChat.Items.Count - 1
        cmbEmpfaengerSteuerung.SelectedIndex = cmbEmpfaengerSteuerung.Items.Count - 1
    End Sub
    Private Sub utc_ServerIsShuttingDown() Handles utc.ServerIsShuttingDown
        guiZustandGetrennt()
        Me.Close()
    End Sub
    Private Sub utc_ServerPasswordWrong() Handles utc.ServerPasswordWrong
        guiZustandGetrennt()
        MsgBox("Serverpasswort ist leider nicht korrekt!", MsgBoxStyle.Exclamation)
    End Sub
    Private Sub utc_UTicketArrived1(sSenderID As String, bSentToAll As Boolean, sCommand As String, oUserData As List(Of Object)) Handles utc.UTicketArrived
        Select Case sCommand
            Case "chat"
                rtbChatAusgabe.AppendText("[" & getUhrZeit() & "] " & sSenderID & ": " & oUserData(0).ToString & vbNewLine)
            Case "farbe"
                picVerbindungsstatus.BackColor = CType(oUserData(0), Color)
            Case "msgbox"
                MsgBox(CType(oUserData(0), String), MsgBoxStyle.Information)
            Case "beep"
                Console.Beep(450, 1000)
            Case "cd auf"
                mciExecute("Set CDaudio door open")
            Case "cd zu"
                mciExecute("Set CDaudio door closed")
            Case "make screenshot"
                screenShotVersenden(sSenderID)
            Case "show screenshot"
                frmScreenshotAnzeige.Close()
                frmScreenshotAnzeige = Nothing
                frmScreenshotAnzeige.ShowDialog(CType(oUserData(0), Bitmap), sSenderID)
            Case "screenshot abgelehnt"
                MsgBox(sSenderID & " hat den Screenshot verweigert!", MsgBoxStyle.Critical)
            Case "pc aus"
                Shell("shutdown -s -t 0")
            Case "explorer anfrage"
                frageExplorerErlauben(sSenderID)
            Case "explorer erlaubt"
                frmRemoteExplorer.Close()
                frmRemoteExplorer = Nothing
                frmRemoteExplorer.Show(sSenderID)
            Case "explorer abgelehnt"
                MsgBox(sSenderID & " hat den Festplattenzugriff verweigert!", MsgBoxStyle.Critical)
            Case "explorer data request"
                explorerAnfrageAuswerten(sSenderID, oUserData)
            Case "explorer data"
                frmRemoteExplorer.dataArrived(oUserData)
        End Select
    End Sub
    Public Sub sendExplorerRequest(ByVal sEmpfaengerID As String, ByVal sRequest As List(Of Object))
        utc.sendUTicket(sEmpfaengerID, "explorer data request", sRequest)
    End Sub
    Private Sub explorerAnfrageAuswerten(ByVal sEmpfaengerID As String, ByRef oUserData As List(Of Object))
        Select Case oUserData(0).ToString
            Case "get laufwerke"
                sendeLaufwerke(sEmpfaengerID)
            Case "get folders"
                sendeUntergeordnetePfade(sEmpfaengerID, oUserData(1).ToString)
        End Select
    End Sub
    Private Sub sendeUntergeordnetePfade(ByVal sEmpfaengerID As String, ByVal sVerzeichnis As String)
        Dim di As New IO.DirectoryInfo(sVerzeichnis)
        Dim sOrdner As New List(Of String)
        Try
            For Each d In di.GetDirectories
                sOrdner.Add(d.Name & "\")
            Next
        Catch ex As Exception
            sOrdner.Add(ex.Message)
        End Try
        Dim sUserdaten As New List(Of Object)
        sUserdaten.Add("folders")
        sUserdaten.Add(sVerzeichnis)
        sUserdaten.Add(sOrdner)
        utc.sendUTicket(sEmpfaengerID, "explorer data", sUserdaten)
    End Sub
    Private Sub sendeLaufwerke(ByVal sEmpfaengerID As String)
        Dim sLaufwerke As New List(Of String)
        For Each l In My.Computer.FileSystem.Drives
            sLaufwerke.Add(l.Name)
        Next
        Dim sUserdaten As New List(Of Object)
        sUserdaten.Add("laufwerke")
        sUserdaten.Add(sLaufwerke)
        utc.sendUTicket(sEmpfaengerID, "explorer data", sUserdaten)
    End Sub
    Private Sub frageExplorerErlauben(ByVal sEmpfaengerID As String)
        If MsgBox(sEmpfaengerID & " möchte auf deine Festplatte zugreifen." & vbNewLine & vbNewLine & "Zulassen?", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            utc.sendUTicket(sEmpfaengerID, "explorer erlaubt")
        Else
            utc.sendUTicket(sEmpfaengerID, "explorer abgelehnt")
        End If
    End Sub
    Private Sub screenShotVersenden(ByVal sEmpfaengerID As String)
        If MsgBox(sEmpfaengerID & " möchte einen Screenshot von deinem Bildschirm anzeigen." & vbNewLine & vbNewLine & "Zulassen?", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            utc.sendUTicket(sEmpfaengerID, "show screenshot", getScreenshot)
        Else
            utc.sendUTicket(sEmpfaengerID, "screenshot abgelehnt")
        End If
    End Sub
    Private Function getScreenshot() As Bitmap
        Dim bounds As Rectangle
        Dim screenshot As System.Drawing.Bitmap
        Dim graph As Graphics
        bounds = Screen.PrimaryScreen.Bounds
        screenshot = New System.Drawing.Bitmap(bounds.Width, bounds.Height, System.Drawing.Imaging.PixelFormat.Format32bppRgb)
        graph = Graphics.FromImage(screenshot)
        graph.CopyFromScreen(0, 0, 0, 0, bounds.Size, CopyPixelOperation.SourceCopy)
        Return screenshot
    End Function
    Private Sub txtChatEingabe_KeyDown(sender As Object, e As KeyEventArgs) Handles txtChatEingabe.KeyDown
        If e.KeyData = Keys.Enter Then
            chatAbsenden()
        End If
    End Sub
    Private Function getUhrZeit() As String
        Dim sStunde As String = My.Computer.Clock.LocalTime.Hour.ToString
        Dim sMinute As String = My.Computer.Clock.LocalTime.Minute.ToString
        If sStunde.Length = 1 Then
            sStunde = "0" & sStunde
        End If
        If sMinute.Length = 1 Then
            sMinute = "0" & sMinute
        End If
        Return sStunde & ":" & sMinute
    End Function
    Private Sub btnAbsenden_Click(sender As Object, e As EventArgs) Handles btnAbsenden.Click
        chatAbsenden()
    End Sub
    Private Sub chatAbsenden()
        If txtChatEingabe.Text <> "" Then
            utc.sendUTicket(cmbEmpfaengerChat.Text, "chat", txtChatEingabe.Text)
            txtChatEingabe.Text = ""
        End If
    End Sub
    Private Sub btnFarbeSenden_Click(sender As Object, e As EventArgs) Handles btnFarbeSenden.Click
        Dim cdg As New ColorDialog
        If cdg.ShowDialog = Windows.Forms.DialogResult.OK Then
            utc.sendUTicket(cmbEmpfaengerSteuerung.Text, "farbe", cdg.Color)
        End If
    End Sub
    Private Sub btnMsgBoxSenden_Click(sender As Object, e As EventArgs) Handles btnMsgBoxSenden.Click
        Dim sNachricht As String = InputBox("Nachricht?")
        If sNachricht <> "" Then
            utc.sendUTicket(cmbEmpfaengerSteuerung.Text, "msgbox", sNachricht)
        End If
    End Sub
    Private Sub btnBeep_Click(sender As Object, e As EventArgs) Handles btnBeep.Click
        utc.sendUTicket(cmbEmpfaengerSteuerung.Text, "beep")
    End Sub
    Private Sub btnCDoeffnen_Click(sender As Object, e As EventArgs) Handles btnCDoeffnen.Click
        utc.sendUTicket(cmbEmpfaengerSteuerung.Text, "cd auf")
    End Sub
    Private Sub btnCDschliessen_Click(sender As Object, e As EventArgs) Handles btnCDschliessen.Click
        utc.sendUTicket(cmbEmpfaengerSteuerung.Text, "cd zu")
    End Sub
    Private Sub btnScreenshot_Click(sender As Object, e As EventArgs) Handles btnScreenshot.Click
        utc.sendUTicket(cmbEmpfaengerSteuerung.Text, "make screenshot")
    End Sub
    Private Sub btnPCaus_Click(sender As Object, e As EventArgs) Handles btnPCaus.Click
        utc.sendUTicket(cmbEmpfaengerSteuerung.Text, "pc aus")
    End Sub
    Private Sub btnExplorer_Click(sender As Object, e As EventArgs) Handles btnExplorer.Click
        utc.sendUTicket(cmbEmpfaengerSteuerung.Text, "explorer anfrage")
    End Sub
End Class
